
import sys
from setuptools import setup

# use the version of the framework package as the base version:
try:
    import kabaret.version
except ImportError:
    version = '0.0.0a1'
else:
    version = kabaret.version.get()


if not hasattr(sys, 'version_info') or sys.version_info < (2, 6, 0, 'final'):
    raise SystemExit("Kabaret requires Python 2.6 or later.")

install_requires = ['kabaret.core', 'kabaret.flow', 'kabaret.naming', 'kabaret.gui']

setup(
    name='kabaret.studio',
    namespace_packages=['kabaret'],
    packages=[
        'kabaret',
        'kabaret.studio', 
        'kabaret.studio.apps', 
        'kabaret.studio.clients',
        'kabaret.studio.clients.flow_gui',
        'kabaret.studio.clients.flow_gui.icons',
        'kabaret.studio.clients.flow_gui.icons.nodes',
        'kabaret.studio.clients.maya',
        'kabaret.studio.clients.naming_gui',
        'kabaret.studio.clients.nuke',
        'kabaret.studio.clients.system_cmds_gui',
        'kabaret.studio.clients.system_cmds_gui.icons',
        'kabaret.studio.clients.versions_gui',
        'kabaret.studio.clients.versions_gui.icons',
        'kabaret.studio.flow',
        'kabaret.studio.flow.nodelib',
        'kabaret.studio.flow.projects',
        'kabaret.studio.naming',
        'kabaret.studio.naming.examples',
        'kabaret.studio.reversion',
    ],
    include_package_data=True, # needed for icons
    version=version,
    install_requires=install_requires,
    description='Complete implementation of a digital creation studio using the kabaret framework.',
    url='http://packages.python.org/kabaret',
    author='Damien Coureau',
    author_email='dee@dee909.com',
    classifiers=[
        'Development Status :: 2 - Pre-Alpha',
        
        'Topic :: Office/Business :: Groupware',
        'Topic :: Office/Business :: Scheduling',
        
        'Intended Audience :: Developers',
        'Intended Audience :: End Users/Desktop',
        
        'Operating System :: OS Independent',
        
        'Programming Language :: Python :: 2.6',
        'Programming Language :: Python :: 2.7',
        
        'License :: OSI Approved :: GNU Lesser General Public License v3 or later (LGPLv3+)',
    ],
)